xfs
[Top] [All Lists]

[PATCH 2/2 V3] xfstests: test EROFS vs. EEXIST when creating on an RO fi

To: xfs-oss <xfs@xxxxxxxxxxx>
Subject: [PATCH 2/2 V3] xfstests: test EROFS vs. EEXIST when creating on an RO filesystem
From: Eric Sandeen <sandeen@xxxxxxxxxxx>
Date: Wed, 09 Jan 2013 10:17:59 -0600
Cc: Ben Myers <bpm@xxxxxxx>
In-reply-to: <50ED9726.4030008@xxxxxxxxxxx>
References: <50B52DB7.3030506@xxxxxxxxxx> <50ED9726.4030008@xxxxxxxxxxx>
User-agent: Mozilla/5.0 (Macintosh; Intel Mac OS X 10.8; rv:17.0) Gecko/17.0 Thunderbird/17.0
TBH, I don't know if this is posix-specified, but I found out the
hard way that when trying to re-create existing files on a readonly 
filesystem, some apps expect/handle EEXIST, but fail on EROFS.

This will test mkdir, mknod, and symlinks for that behavior.

Signed-off-by: Eric Sandeen <sandeen@xxxxxxxxxx>
---

V2: Change test dir var name, do scratch mkfs, drop _fail
V3: Use common _filter_ln


diff --git a/293 b/293
new file mode 100755
index 0000000..9013f9a
--- /dev/null
+++ b/293
@@ -0,0 +1,73 @@
+#! /bin/bash
+# FS QA Test No. 293
+#
+# Tests for EEXIST (not EROFS) for inode creations, if
+# we ask to create an already-existing entity on an RO filesystem
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2012 Red Hat, Inc.  All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#-----------------------------------------------------------------------
+#
+# creator
+owner=sandeen@xxxxxxxxxx
+
+seq=`basename $0`
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1       # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+    cd /
+    rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common.rc
+. ./common.filter
+
+# real QA test starts here
+
+# Modify as appropriate.
+_supported_fs generic
+_supported_os Linux
+_require_scratch
+
+THIS_TEST_DIR=$SCRATCH_MNT/$seq.test
+
+_create_files()
+{
+       mknod $THIS_TEST_DIR/testnode c 1 3
+       mkdir $THIS_TEST_DIR/testdir
+       touch $THIS_TEST_DIR/testtarget
+       ln -s $THIS_TEST_DIR/testtarget $THIS_TEST_DIR/testlink | _filter_ln
+}
+
+_scratch_mount
+
+rm -rf $THIS_TEST_DIR
+mkdir $THIS_TEST_DIR || _fail "Could not create dir for test"
+
+_create_files 2>&1 | _filter_scratch
+_scratch_mount -o remount,ro || _fail "Could not remount scratch readonly"
+_create_files 2>&1 | _filter_scratch
+
+# success, all done
+status=0
+exit
diff --git a/293.out b/293.out
new file mode 100644
index 0000000..9075d3c
--- /dev/null
+++ b/293.out
@@ -0,0 +1,5 @@
+QA output created by 293
+mknod: `SCRATCH_MNT/293.test/testnode': File exists
+mkdir: cannot create directory `SCRATCH_MNT/293.test/testdir': File exists
+touch: cannot touch `SCRATCH_MNT/293.test/testtarget': Read-only file system
+ln: creating symbolic link `SCRATCH_MNT/293.test/testlink': File exists
diff --git a/group b/group
index c32839b..1fdae31 100644
--- a/group
+++ b/group
@@ -411,3 +411,4 @@ deprecated
 290 auto rw prealloc quick ioctl
 291 repair
 292 auto mkfs quick
+293 auto quick


<Prev in Thread] Current Thread [Next in Thread>